/*============================================*/
/*==== Ragemap 2024 map A script - v 1.00 ====*/
/*============================================*/



/*
 * -------------------------------------------------------------------------
 * Includes
 * -------------------------------------------------------------------------
 */

#include "ragemap2024"
#include "weapon_custom/v9/weapon_custom"
#include "bonk"
#include "erty"
#include "giegue"
#include "grunt"



/*
 * -------------------------------------------------------------------------
 * Life cycle functions
 * -------------------------------------------------------------------------
 */

/**
 * Map initialisation handler.
 * @return void
 */
void MapInit()
{
    // Shared script
    Ragemap2024::MapInit();

    // weapon_custom
    WeaponCustomMapInit();

    // Erty's script
    Ragemap2024Erty::MapInit();

    // Giegue's script
    GIEGUE::MapInit();

    // Grunt's script
    FLY::MapInit();
}

/**
 * Map activation handler.
 * @return void
 */
void MapActivate()
{
    // Shared script
    Ragemap2024::MapActivate();

    // weapon_custom
    WeaponCustomMapActivate();

    // Erty's script
    Ragemap2024Erty::MapActivate();
}
